package br.usp.nds.agualastro.modelo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import br.usp.nds.agualastro.integracao.Carregador;
import br.usp.nds.agualastro.integracao.Mensagem;
import br.usp.nds.agualastro.persistencia.PersistenciaFacade;

public class Atualizador {

	private Timer timer = new Timer();
	private static Atualizador instance;
	
	public void atualizar() throws Exception {
		for (Mensagem mensagem : new Carregador().carregar()) {
			byte[] instante = mensagem.getInstante();
			try {
				new PersistenciaFacade().registrar(new SimpleDateFormat("ssmmHHddMMyy").parse(String.format("%02d", instante[0]) + String.format("%02d", instante[1]) + 
						String.format("%02d", instante[2]) + String.format("%02d", instante[3]) + String.format("%02d", instante[4]) + String.format("%02d", instante[5])), 
						mensagem.getLatitude(), mensagem.getLongitude(), mensagem.getSensores(), mensagem.getEmail());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	public void iniciar() {
		timer.scheduleAtFixedRate(new TimerTask() {
			
			@Override
			public void run() {
				try {
					new Atualizador().atualizar();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}, new Date(), 1000 * 60 * 10);
	}

	public void parar() {
		timer.cancel();
	}
	
	public synchronized static Atualizador getInstance() {
		if (instance == null) {
			instance = new Atualizador();
		}
		return instance;
	}
	
	public Atualizador() {
	}
}
