package br.usp.nds.agualastro.satelites;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;

import org.json.JSONArray;
import org.json.JSONObject;

public class Informante {

	public Satelite consultarSatelite(String norad) {
		StringBuilder json = new StringBuilder();
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader((InputStream)new URL("http://www.n2yo.com/sat/instant-tracking.php?s=" + norad + 
					"&hlat=-23.5475&hlng=-46.63611&d=1&r=710770119687.2213&tz=GMT-02:00&O=n2yocom&rnd_str=78f6d7025463d0f05a0d8b6ec6cec9d8").getContent()));
			for (String line = br.readLine(); line != null; line = br.readLine()) {
				json.append(line);
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("json = " + json.toString());
		JSONArray pos = ((JSONObject)new JSONArray(json.toString()).get(0)).getJSONArray("pos");
		if (pos.length() > 0) {
			String[] ds = ((JSONObject)pos.get(0)).getString("d").split("[|]");
			if (!ds[0].isEmpty() && !ds[1].isEmpty()) {
				return new Satelite(norad, Float.parseFloat(ds[0]), Float.parseFloat(ds[1]));
			}
		}
		return new Satelite(norad, 0, 0);
	}
}
